#include "cdictparser.h"
#include <stdio.h>


bool CDictParser::startDocument()
{
  valid=false;
  copyright=FALSE;

  return TRUE;
}

bool CDictParser::startElement(const QString &, const QString &, const QString &qName, const QXmlAttributes &attr)
{
  QString str;
  int i;

//printf("start %s\n", qName.latin1());
  if(qName=="entry")
  {
    i=attr.index("id");
    if(i!=-1)
    {
      str="<div style=\"font-size:32pt;color:#800000;\">";
      str+=attr.value(i);
      str+="</div>";
      lb->insertItem(attr.value(i));
      valid=TRUE;
      meanings->push_back(str);
    }
  }
  else if(qName=="copyright")
    copyright=TRUE;
  if(valid)
  {
    i=tagnames->findIndex(qName);
    if(i!=-1)
      (*meanings)[meanings->count()-1]+=(*begintags)[i];
  }

  return TRUE;
}

bool CDictParser::characters(const QString &ch)
{
  if(copyright)
  {
    copylabel->setText(ch);
    copyright=FALSE;
  }
  if(valid)
    (*meanings)[meanings->count()-1]+=ch;

  return TRUE;
}

bool CDictParser::endElement(const QString &, const QString &, const QString &qName)
{
  int i;
  
//  printf("end %s\n", qName.latin1());
  if(valid)
  {
    i=tagnames->findIndex(qName);
    if(i!=-1)
      (*meanings)[meanings->count()-1]+=(*endtags)[i];
  }
  if(qName=="entry")
    valid=FALSE;

  return TRUE;
}
