#include <stdio.h>
#include <string>
#include <vector>

#define MAX_STR_LEN 1024

using namespace std;

typedef struct Section
{
  string name;
  vector<string> keys;
  vector<string> vals;
};

class CIniFile
{
  private:
    string filename;
    vector<Section> sections;
  public:
    CIniFile(const char *fn);
    ~CIniFile();
    vector<string> getSection(string section);
    vector<string> getSectionValues(string section);
    string getValue(string section, string key, string def);
    int getInt(string section, string key, int def);
    void setValue(string section, string key, string val);
    void setInt(string section, string key, int val);
    void setSectionValues(string section, vector<string> keys, vector<string> vals);
    void deleteSection(string section);
    void deleteKey(string section, string key);
    void flush();
};
